﻿using System;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;

namespace ConsoleApp1
{
    class Program
    {
        [DllImport("kernel32.dll")]
        extern static uint GetACP();

        static void Main(string[] args)
        {
            Console.WriteLine("ANSI code page identifier: " + GetACP());

            SetDefaultEncoding(Encoding.ASCII);
            Console.WriteLine(Encoding.Default.EncodingName);

            SetDefaultEncoding(Encoding.UTF8);
            Console.WriteLine(Encoding.Default.EncodingName);
        }

        private static void SetDefaultEncoding(Encoding encoding)
        {
            Type type = typeof(System.Text.Encoding);
            FieldInfo field = type.GetField("defaultEncoding", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Static);
            field.SetValue(null, encoding);
        }
    }
}
